/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_POLL
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

/* This file is part of mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

static size_t last_poll_host_loc
#line 19 "bi_poll.m4"
;
static size_t last_poll_send_loc
#line 20 "bi_poll.m4"
;
static size_t last_poll_recv_loc
#line 21 "bi_poll.m4"
;
static size_t cache_used_loc
#line 22 "bi_poll.m4"
;

void
set_last_poll_result(eval_environ_t env,
		     const char *host_addr,
		     const char *send, const char *recv)
{
	
#line 29
{ size_t off;
#line 29
  if (host_addr)
#line 29
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(host_addr) + 1)), host_addr);
#line 29
  else
#line 29
     off = 0;
#line 29
  *env_data_ref(env, last_poll_host_loc) = (STKVAL) (off); }
#line 29
;
	
#line 30
{ size_t off;
#line 30
  if (send)
#line 30
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(send) + 1)), send);
#line 30
  else
#line 30
     off = 0;
#line 30
  *env_data_ref(env, last_poll_send_loc) = (STKVAL) (off); }
#line 30
;
	
#line 31
{ size_t off;
#line 31
  if (recv)
#line 31
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(recv) + 1)), recv);
#line 31
  else
#line 31
     off = 0;
#line 31
  *env_data_ref(env, last_poll_recv_loc) = (STKVAL) (off); }
#line 31
;
}

void
set_cache_used(eval_environ_t env, int value)
{
	*env_data_ref(env, cache_used_loc) = (STKVAL) (value);
}


void
#line 41
bi_stdpoll(eval_environ_t env)
#line 41

#line 41 "bi_poll.m4"
{
#line 41
	
#line 41

#line 41

#line 41
char * email = (char *) get_string_arg(env, 0);
#line 41
        char * ehlo = (char *) get_string_arg(env, 1);
#line 41
        char * mailfrom = (char *) get_string_arg(env, 2);
#line 41
        
#line 41
        adjust_stack(env, 3);
#line 41

#line 41
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 41
		prog_trace(env, "stdpoll %s %s %s",email, ehlo, mailfrom);;
#line 41

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STANDARD POLL FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, ehlo, mailfrom);
	rc = method_standard(env, email, ehlo, mailfrom);
		if (!(mf_resolved(rc)))
#line 51
			env_throw_bi(env, rc, "stdpoll", _("Unhandled exception %s"),mf_status_str(rc))
;
			
	
#line 54
do {
#line 54
  push(env, (STKVAL) (rc));
#line 54
  return;
#line 54
} while (0);	
}
}

void
#line 58
bi_strictpoll(eval_environ_t env)
#line 58

#line 58 "bi_poll.m4"
{
#line 58
	
#line 58

#line 58

#line 58
char * host = (char *) get_string_arg(env, 0);
#line 58
        char * email = (char *) get_string_arg(env, 1);
#line 58
        char * ehlo = (char *) get_string_arg(env, 2);
#line 58
        char * mailfrom = (char *) get_string_arg(env, 3);
#line 58
        
#line 58
        adjust_stack(env, 4);
#line 58

#line 58
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 58
		prog_trace(env, "strictpoll %s %s %s %s",host, email, ehlo, mailfrom);;

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STRICT POLL FOR %s HOST %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = method_strict(env, email, host, ehlo, mailfrom);
		if (!(mf_resolved(rc)))
#line 71
			env_throw_bi(env, rc, "strictpoll", _("Unhandled exception %s"),mf_status_str(rc))
;
	
	
#line 74
do {
#line 74
  push(env, (STKVAL) (rc));
#line 74
  return;
#line 74
} while (0);	
}
}

void
#line 78
bi__pollhost(eval_environ_t env)
#line 78

#line 78 "bi_poll.m4"
{
#line 78
	
#line 78

#line 78

#line 78
char * host = (char *) get_string_arg(env, 0);
#line 78
        char * email = (char *) get_string_arg(env, 1);
#line 78
        char * ehlo = (char *) get_string_arg(env, 2);
#line 78
        char * mailfrom = (char *) get_string_arg(env, 3);
#line 78
        
#line 78
        adjust_stack(env, 4);
#line 78

#line 78
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 78
		prog_trace(env, "_pollhost %s %s %s %s",host, email, ehlo, mailfrom);;

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLHOST %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = check_on_host(env, email, host, ehlo, mailfrom);

		if (!(mf_resolved(rc)))
#line 92
			env_throw_bi(env, rc, "_pollhost", _("Unhandled exception %s"),mf_status_str(rc))
;
	
	
#line 95
do {
#line 95
  push(env, (STKVAL) (rc));
#line 95
  return;
#line 95
} while (0);	
}
}

void
#line 99
bi__pollmx(eval_environ_t env)
#line 99

#line 99 "bi_poll.m4"
{
#line 99
	
#line 99

#line 99

#line 99
char * domain = (char *) get_string_arg(env, 0);
#line 99
        char * email = (char *) get_string_arg(env, 1);
#line 99
        char * ehlo = (char *) get_string_arg(env, 2);
#line 99
        char * mailfrom = (char *) get_string_arg(env, 3);
#line 99
        
#line 99
        adjust_stack(env, 4);
#line 99

#line 99
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 99
		prog_trace(env, "_pollmx %s %s %s %s",domain, email, ehlo, mailfrom);;

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLMX %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      domain, email, ehlo, mailfrom);

	rc = check_mx_records(env, email, domain, ehlo, mailfrom, NULL);

		if (!(mf_resolved(rc)))
#line 112
			env_throw_bi(env, rc, "_pollmx", _("Unhandled exception %s"),mf_status_str(rc))
;

	
#line 115
do {
#line 115
  push(env, (STKVAL) (rc));
#line 115
  return;
#line 115
} while (0);	
}
}


#line 119
void
#line 119
poll_init_builtin()
#line 119
{
#line 119
	#line 19 "bi_poll.m4"
	last_poll_host_loc = builtin_variable_install("last_poll_host", dtype_string, VAR_VOLATILE)->off;
#line 20 "bi_poll.m4"
	last_poll_send_loc = builtin_variable_install("last_poll_send", dtype_string, VAR_VOLATILE)->off;
#line 21 "bi_poll.m4"
	last_poll_recv_loc = builtin_variable_install("last_poll_recv", dtype_string, VAR_VOLATILE)->off;
#line 22 "bi_poll.m4"
	cache_used_loc = builtin_variable_install("cache_used", dtype_number, VAR_VOLATILE)->off;
#line 41 "bi_poll.m4"
va_builtin_install_ex("stdpoll", bi_stdpoll, 0, 0, dtype_number, 3, 0, 0, dtype_string, dtype_string, dtype_string);
#line 58 "bi_poll.m4"
va_builtin_install_ex("strictpoll", bi_strictpoll, 0, 0, dtype_number, 4, 0, 0, dtype_string, dtype_string, dtype_string, dtype_string);
#line 78 "bi_poll.m4"
va_builtin_install_ex("_pollhost", bi__pollhost, 0, 0, dtype_number, 4, 0, 0, dtype_string, dtype_string, dtype_string, dtype_string);
#line 99 "bi_poll.m4"
va_builtin_install_ex("_pollmx", bi__pollmx, 0, 0, dtype_number, 4, 0, 0, dtype_string, dtype_string, dtype_string, dtype_string);

#line 119 "bi_poll.m4"
		
#line 119
}
#line 549 "../src/snarf.m4"

#line 549

